% Mystara Weather System by Ramses Ramirez
% 3/24/01

% Nation codes

Glantri=1;
Karameikos=2;

nation = input('Weather Information for Which Nation of the Known World?(Karameikos, Glantri..etc) ');

% Glantri City Weather Database.

if nation== Glantri
Winter= [25 15];
Spring= [45 30];
Summer= [65 50];
Fall= [50 35];
ProbWinter=15;
ProbSpring=20;
ProbSummer=25;
ProbFall=20;
FogWinter=15;
FogSpring=25;
FogSummer=30;
FogFall=25;

% Karameikos City Weather Database.

elseif nation== Karameikos
Winter= [45 35];
Spring= [55 45];
Summer= [70 60];
Fall= [60 50];
ProbWinter= 35;
ProbSpring=40;
ProbSummer=30;
ProbFall=40;
FogWinter=15;
FogSpring=35;
FogSummer=30;
FogFall=20;
end


Season= input('What is the season?(Winter,Spring, Summer,Fall)')

% Temp is a flag for either Winter, Spring Summer, Fall as used for modification of base temps later on.

if Season == Winter
   ProbPrec=ProbWinter
   Fog=FogWinter
   Temp=1
elseif Season==Spring
   ProbPrec=ProbSpring
   Fog=FogSpring
   Temp=2
elseif Season==Summer
   ProbPrec=ProbSummer
   Fog=FogSummer
   Temp=3
else
   ProbPrec=ProbFall
   Fog=FogFall
   Temp=4
end

%ProbPrec= input('Precipitation Probability for which season?(ProbWinter,ProbFall..etc)')
%Fog= input('Fog stats for which season?(FogWinter,FogSummer..etc)')

% 1 month of die rolls with a d10. Should be changed every month

dice= [4 2 9 7 3 3 5 10 6 4 7 7 1 9 2 6 5 7 8 5 10 9 6 8 4 5 7 2];

%Percent matrix is what is rolled on the d100 that day in the determination of precipitation or not. Should be changed every month
%If the Percent matrix value is less than or equal to the ProbPrec, precipitation will occur that day. 
%FogPercent Matrix is fog probability and it is just the flip matrix of the Percent Matrix.

Percent=[93 83 73 33 96 64 1 53 39 20 20 38 78 48 47 2 28 10 54 17 80 99 51 15 16 44 48 97]; 
FogPercent= abs([100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100 100]-Percent);

% Winddice vector is for the determination of wind direction. It used a d20+1.

winddice= [21 21 3 20 4 9 12 10 5 2 12 15 18 8 12 11 12 18 12 12 17 8 6 18 21 8 8 9]

% Windchill reduce temps by 1d6+9 degrees when there are high winds. Default is 10 degrees

windchill= 10;

% Random Seasonal Trends that have fluctuating effects on standard season conditions for
% Precipitation and Temperature.

opt= input('Roll d10 to see if season is conventional or not')
if opt==1
   Season=Season - [10 10]
   ProbPrec= 10+ ProbPrec
elseif opt==2
   Season= Season - [5 5]
   ProbPrec= 5 +ProbPrec
elseif opt==3
      Season=Season- [5 5]
      ProbPrec= 5+ProbPrec
   elseif opt==4
      Season= Season
      ProbPrec=ProbPrec
   elseif opt==5
      Season=Season
      ProbPrec=ProbPrec
   elseif opt==6 
      Season=Season
      ProbPrec=ProbPrec
   elseif opt==7
      Season=Season
      ProbPrec=ProbPrec
   elseif opt==8
      Season= Season + [5 5]
      ProbPrec= ProbPrec-5
   elseif opt==9
      Season= Season + [5 5]
      ProbPrec= ProbPrec -5
   elseif opt==10
      Season= Season+ [10 10]
      ProbPrec= ProbPrec-10
   end
end
pause

% Initial Conditions in determination of Precipitation Matrix

x=1;
y=1;

% 
for j=1:28
   if Percent(j)<= ProbPrec
      
      % Day Number which corresponds to Precipation Days
      
      DayNumber(y)=j;
      PrecNumber(y)= Percent(j);
      
      % Intensity Numbers founded to determine type/strength of precipitation
      
      intensity(x)=mod(PrecNumber(y),10);
      x= x+1;
      y= y+1;
   end
end

% Determination of precipitation type according to intensity value. 
% The Time precipitation starts is just twice the value of the 1d10 roll
% for that day. The duration in hours for the precipitation is just the 
% addition of the 2 digits from the 1d00 Percentage roll.

for r= 1:length(intensity)
   if intensity(r) ==1
      Day=DayNumber(r)
      input('light drizzle or flurry.')
      Timestart= 2*dice(Day)
      digit1= mod(Percent(Day),10);
      digit2=floor(Percent(Day)/10);
      duration_in_hours= digit1+digit2
      Prec=PrecNumber(r);
      
   elseif intensity(r)==2
      Day=DayNumber(r)
      input('light drizzle or flurry')
      Timestart=2*dice(Day)
      digit1= mod(Percent(Day),10);
      digit2=floor(Percent(Day)/10);
      duration_in_hours= digit1+digit2
      Prec=PrecNumber(r);
      
      elseif intensity(r)==3
         Day=DayNumber(r)
         input('light rain or snow(accumulates 1-6 in total)')
         Timestart=2*dice(Day)
         digit1= mod(Percent(Day),10);
         digit2=floor(Percent(Day)/10);
         duration_in_hours= digit1+digit2
         Prec= PrecNumber(r);
         
         elseif intensity(r)==4
            Day=DayNumber(r)
            input('light rain or snow(accumulates 1-6 in total)')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         elseif intensity(r)==5
            Day=DayNumber(r)
            input('light rain or snow(accumulates 1-6 in total)')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         elseif intensity(r)==6
            Day=DayNumber(r)
            input('light rain or snow(accumulates 1-6 in total)')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         elseif intensity(r)==7
            Day=DayNumber(r)
            input('heavy rain or snow(1 in per hour)')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         elseif intensity(r)==8
            Day=DayNumber(r)
            input('heavy rain or snow(1 in per hour)')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         elseif intensity(r)==9
            Day=DayNumber(r)
            input('heavy rain or snow')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         elseif intensity(r)==0
            Day=DayNumber(r)
            input('thunderstorm or snowstorm(2 in per hour)')
            Timestart=2*dice(Day)
            digit1= mod(Percent(Day),10);
            digit2=floor(Percent(Day)/10);
            duration_in_hours= digit1+digit2
            Prec=PrecNumber(r);
            
         end
      end
   end
   
      
            
            
   end
end


for n=1:28
   DayNumber=n
   if FogPercent(n) <= Fog
      input('There is fog today at dawn or dusk. Fog lasts 1d4 hours')
      digit1= mod(Percent(n),10);
      digit2= floor(Percent(n)/10);
      visibilityinfeet=digit1*digit2
   end
   
   % Loop which computes base temperatures for each day and wind intensity 
   
if dice(n) ==1 
   input('little or no winds')
   HighTemp = Season(1);
   LowTemp = Season(2);
	elseif dice(n)==2
      input('little or no winds')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==3 
      input('moderate breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==4
      input('moderate breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==4 
      input('moderate breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==5 
      input('moderate breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==6
      input('moderate breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==7
      input('strong breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==8
      input('strong breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==9
      input('strong breeze')
      HighTemp= Season(1);
      LowTemp= Season(2);
   elseif dice(n)==10
      input('high winds')
      HighTemp= Season(1)-(windchill);
      LowTemp= Season(2) -(windchill);
   end
   
   % These if statements take base temperatures from above and modify them with the dice d10 matrix 
   % depending on the season (add or subtract).
   
   %Winter
   
   if Temp== 1
   LowTemp= LowTemp- dice(n)
   HighTemp= LowTemp+10
   
   %Spring
   
elseif Temp==2
   LowTemp= LowTemp+dice(n)
   HighTemp= LowTemp+10
   
   %Summer
   
elseif Temp==3
   LowTemp= LowTemp+dice(n)
   HighTemp= LowTemp+10
   
   %Fall
   
elseif Temp==4
   LowTemp= LowTemp-dice(n)
   HighTemp= LowTemp+10
end
end




% Loop for Wind direction
% Glantri's dominant winds come from the NW direction

for s= 1:28
   if winddice(s) ==1
      Day= s
      input('Dominant wind direction')
   elseif winddice(s) ==2
      Day= s
      input('Dominant wind direction')
   elseif winddice(s)==3
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==4
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==5
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==6
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==7
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==8
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==8
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==9
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==10
      Day=s
      input('Dominant wind direction')
   elseif winddice(s)==11
      input('Dominant wind direction')
   elseif winddice(s) ==12      
      Day= s
      input('shift wind direction by one hexside clockwise')
   elseif winddice(s)==13
      Day= s
      input('shift wind direction by one hexside clockwise')
   elseif winddice(s)==14
      Day= s
      input('shift wind direction by one hexside counterclockwise')
   elseif winddice(s)==15
      Day= s
      input('shift wind direction by one hexside counterclockwise')
   elseif winddice(s)==16
      Day= s
      input('shift wind direction by 2 hexsides clockwise')
   elseif winddice(s) ==17
      Day = s
      input('shift wind direction by 2 hexsides counterclockwise')
   elseif winddice(s)==18
      Day = s
      input('shift wind direction by 3 hexsides clockwise')
   elseif winddice(s)==19
      Day= s
      input('shift wind direction by 3 hexsides counterclockwise')
   else 
      Day= s
      input('Opposite wind')
   end
end

      
      
input('The second digit in Prec is the number to read off intensity in the Precipitation Chart.')
input('The TimeStart of the Precipitation is the second digit of Prec times 2. Units of Timestart is similar to military time from 1-24')